#! /bin/sh

old_IFS="$IFS"; IFS="$IFS:";
for trial in $PATH
do
  if test -f $trial/hostname; then HOSTNAME="`$trial/hostname`"; fi
  if test -f $trial/uname;    then SYSINFO="`$trial/uname -a`"; fi
done
IFS="$old_IFS";

# disable multiple registrations from the same user/architecture
regfile='.registered-HEASOFT-6.5'
if [ -f $regfile ]; then
   if [ `grep "$SYSINFO" $regfile | wc -w` -ne 0 ]; then
      exit
   fi
fi
touch $regfile
echo "$SYSINFO" >> $regfile

version='6.5'
DATE=`date`
echo "To: ftoolsreg@athena.gsfc.nasa.gov " >> $$.email
echo "Subject: Installation Registration for HEASOFT $version" >> $$.email
echo "" >> $$.email
echo "" >> $$.email
echo "" >> $$.email
echo "    " >> $$.email
echo "System: $SYSINFO" >> $$.email
echo "Date: $DATE" >> $$.email
echo " " >> $$.email
echo " " >> $$.email
echo " " >> $$.email
if [ -d ../suzaku ]; then
  echo "HEADAS installation includes: suzaku" >> $$.email
fi
if [ -d ../ftools ]; then
  echo "HEADAS installation includes: ftools" >> $$.email
fi
if [ -d ../swift ]; then
  echo "HEADAS installation includes: swift" >> $$.email
fi
if [ -d ../Xspec ]; then
  echo "HEADAS installation includes: Xspec" >> $$.email
fi
echo " " >> $$.email
echo " " >> $$.email
echo " " >> $$.email
echo "config.status" >> $$.email
echo " " >> $$.email
cat config.status >> $$.email
if [ -f f77test.out ]; then
   echo f77test >> $$.email
   echo " " >> $$.email
   cat f77test.out >> $$.email
fi

/usr/lib/sendmail -t < $$.email 2> /dev/null
